local mod = RW:Boss("Gunship Battle", "Icecrown Citadel", "Icecrown Citadel", "The Lower Spire")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

---------------------------
-- Variables
local tFightStart
local wBelow, tBelowCD
local wVeteran
local wJetPack

---------------------------
-- Init
function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Gunship Battle"
		
		--21:02] High Overlord Saurfang yells: The Alliance falter.
	
		if UnitFactionGroup("player") == "Horde" then
			L.YellPull = "Kor'kron, take us out!"
			L.YellPull1 = "What is that? Something approaching in the distance."
			L.YellPull2 = "ALLIANCE GUNSHIP! ALL HAND ON DECK!"
		else
			L.YellPull = "UNKNOWN"
			L.YellPull1 = "UNKNOWN"
			L.YellPull2 = "UNKNOWN"
		end
		
		L.fight_start = "Battle begins.."
		L.fight_start_opt = "Timer for when the battle starts"
		L.fight_start_group = "Fight Begin"
		
		L.health_frames = "Show stack frame for "..GetSpellInfo(72306)
		
		L.jetpack_check = "Put Goblin Rocket Pack on!"
		L.jetpack_check_opt = "Missing rocket pack warning"
		L.jetpack_check_group = "Goblin Rocket Pack"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(L.YellPull, L.YellPull1, L.YellPull2, 37215, 37540, 37200)

	if UnitFactionGroup("player") == "Horde" then
		mod:SetWin(37215)
	else
		mod:SetWin("combat")
	end
	
	mod:SetDelay(50)
	
	self:AddBoolOption("HealthFrame", L.health_frames, nil, nil, select(3, GetSpellInfo(72306)))
	
	tFightStart	= self:CustomTimer(45, L.fight_start, L.fight_start_opt, [[Interface\Icons\Achievement_WorldEvent_Valentine]], L.fight_start_group)
	tBelowCD	= self:CDTimer(37, 69705)
	
	wBelow		= self:CastWarning(69705)
	wJetPack	= self:CustomWarning(L.jetpack_check, L.jetpack_check_opt, [[Interface\Icons\ability_mount_rocketmount]], L.jetpack_check_group)
	
	iExp		= self:Icon("SKULL", 71188, false, nil, "CROSS", "SQUARE")
end

---------------------------
-- Locals
local furyStacks


local function updateStack()
	return furyStacks, 25
end

-- Jet pack cheeck
local function JetPackCheck()
	local shirt = GetInventoryItemLink("player", 4)
	if shirt then
		shirt = select(3, shirt:find("item:(%d+):"))
		if shirt ~= "49278" then
			wJetPack:Show()
		end
	end
end

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Below", 69705)
	self:Track("Fury", 72306, 72307, 69638, 69637, 72308)
	
	-- TODO, add alliance mobID for the Below Zero casters
	self:DeathTrack("SourcererDeath", 37116)
	
	furyStacks = 0
	
	if self.db.profile.HealthFrame then
		self:SendMessage("RW_AddHealthFrame", updateStack, GetSpellInfo(72306), select(3, GetSpellInfo(72306)), "STACK")
	end
	
	if trigger then
		JetPackCheck()
	end
	
	tFightStart:Start()
end

function mod:Below(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		wBelow:Show()
		self:SendMessage("RW_AddHealthFrame", mod:CUIDFromGUID(args.sGUID))
	
	elseif event == "SPELL_AURA_REMOVED" then
		tBelowCD:Start()
	end
end

function mod:Fury(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		furyStacks = args.amount or 1
	
	elseif event == "SPELL_AURA_REMOVED" then
		furyStacks = 0
	end
end

function mod:SourcererDeath(event, cID)
	self:SendMessage("RW_RemoveHealthFrame", cID)
end